diff --git a/scripts/njs/user_filter.js b/scripts/njs/user_filter.js
index f2b2491..5111494 100644
--- a/scripts/njs/user_filter.js
+++ b/scripts/njs/user_filter.js
@@ -29,19 +29,23 @@ function check_user(r) {


     if (r.args.username !== undefined && r.args.password !== undefined) {
+
+        var username = decodeURIComponent(r.args.username);
+        var password = decodeURIComponent(r.args.password);
+
         r.warn("Processing uri: " + r.uri);
-        r.warn("Found credentials in request: " + r.args.username + " / " + r.args.password);
+        r.warn("Found credentials in request: " + username + " / " + password);

-        if (r.args.username == 'http:' || r.args.password == '') {
+        if (username == 'http:' || password == '') {
             // workaround for strange requests from valid users
-            r.warn("Ignoring credentilas check for user '" + r.args.username + "' and password '" + r.args.password + "' from IP: " + r.remoteAddress);
+            r.warn("Ignoring credentilas check for user '" + username + "' and password '" + password + "' from IP: " + r.remoteAddress);
             return;
         }

-        if (is_valid_user(r.args.username, r.args.password, r) && is_more_connections_allowed(username, password, r)) {
+        if (is_valid_user(username, password, r) && is_more_connections_allowed(username, password, r)) {
             return "good user";
         } else {
-            r.warn("Bad user: " + r.args.username + " / " + r.args.password + " from " + r.remoteAddress)
+            r.warn("Bad user: " + username + " / " + password + " from " + r.remoteAddress)
             return "bad user";
         }
     }
@@ -61,8 +65,8 @@ function check_user(r) {
     for (var i = 0; i < credential_patterns.length; i++) {
         var match = r.uri.match(credential_patterns[i]);
         if (match) {
-            var username = match[1];
-            var password = match[2];
+            var username = decodeURIComponent(match[1]);
+            var password = decodeURIComponent(match[2]);

             r.warn("Processing uri: " + r.uri);
             r.warn("Found credentials in request: " + username + " / " + password);

